<template>
  <div class="wisdom">
    <div class="title">
      <span>智慧安监</span>
      <img src="../../../assets/img/zonlan (9).png" alt="" />
    </div>
    <div class="content">
      <div class="Icon" id="top_icon"></div>
      <div class="Icon" id="bottom_icon"></div>
    </div>
  </div>
</template>

<script>
export default {
  //import引入的组件需要注入到对象中才能使用
  components: {},
  data() {
    //这里存放数据
    return {};
  },
  //方法集合
  methods: {
    async topDrawLine() {
      const { data: dt } = await this.$http.get(
        "/jeecg-boot/report/report/queryall"
      );
      var valueData = dt.result;
      var echartData = [];
      for (var i in valueData) {
        echartData.push({
          name: valueData[i].month,
          value1: valueData[i].dangers,
          value2: valueData[i].risk,
        });
      }
      let Chart = this.$echarts.init(document.getElementById("top_icon"));
      let color = [
        "#0090FF",
        "#36CE9E",
        "#FFC005",
        "#FF515A",
        "#8B5CFF",
        "#00CA69",
      ];

      let xAxisData = echartData.map((v) => v.name);
      //    ["1", "2", "3", "4", "5", "6", "7", "8"]
      let yAxisData1 = echartData.map((v) => v.value1);
      // [100, 138, 350, 173, 180, 150, 180, 230]
      let yAxisData2 = echartData.map((v) => v.value2);
      // [233, 233, 200, 180, 199, 233, 210, 180]
      const hexToRgba = (hex, opacity) => {
        let rgbaColor = "";
        let reg = /^#[\da-f]{6}$/i;
        if (reg.test(hex)) {
          rgbaColor = `rgba(${parseInt("0x" + hex.slice(1, 3))},${parseInt(
            "0x" + hex.slice(3, 5)
          )},${parseInt("0x" + hex.slice(5, 7))},${opacity})`;
        }
        return rgbaColor;
      };

      let option = {
        color: color,
        legend: {
          right: 10,
          top: 10,
          data: ["重点自查风险隐患", "风险点和危险源"],
        },
        tooltip: {
          trigger: "axis",
          formatter: function (params) {
            let html = "";
            params.forEach((v) => {
              html += `<div style="color: #666;font-size: 14px;line-height: 24px">
                <span style="display:inline-block;margin-right:5px;border-radius:10px;width:10px;height:10px;background-color:${
                  color[v.componentIndex]
                };"></span>
                ${v.seriesName}.${v.name}
                <span style="color:${
                  color[v.componentIndex]
                };font-weight:700;font-size: 18px">${v.value}</span>
                万元`;
            });

            return html;
          },
          extraCssText:
            "background: #fff; border-radius: 0;box-shadow: 0 0 3px rgba(0, 0, 0, 0.2);color: #333;",
          axisPointer: {
            type: "shadow",
            shadowStyle: {
              color: "#ffffff",
              shadowColor: "rgba(225,225,225,1)",
              shadowBlur: 5,
            },
          },
        },
        grid: {
          top: 100,
          containLabel: true,
        },
        xAxis: [
          {
            type: "category",
            boundaryGap: false,
            axisLabel: {
              formatter: "{value}",
              textStyle: {
                color: "#fff",
              },
            },
            axisLine: {
              lineStyle: {
                color: "#fff",
              },
            },
            data: xAxisData,
          },
        ],
        yAxis: [
          {
            type: "value",
            name: "单位：万千瓦时",
            axisLabel: {
              textStyle: {
                color: "#fff",
              },
            },
            nameTextStyle: {
              color: "#fff",
              fontSize: 12,
              lineHeight: 40,
            },
            splitLine: {
              lineStyle: {
                type: "dashed",
                color: "#fff",
              },
            },
            axisLine: {
              show: false,
            },
            axisTick: {
              show: false,
            },
          },
        ],
        series: [
          {
            name: "重点自查风险隐患",
            type: "line",
            smooth: true,
            // showSymbol: false,/
            symbolSize: 8,
            zlevel: 3,
            lineStyle: {
              normal: {
                color: color[0],
                shadowBlur: 3,
                shadowColor: hexToRgba(color[0], 0.5),
                shadowOffsetY: 8,
              },
            },
            areaStyle: {
              normal: {
                color: new this.$echarts.graphic.LinearGradient(
                  0,
                  0,
                  0,
                  1,
                  [
                    {
                      offset: 0,
                      color: hexToRgba(color[0], 0.3),
                    },
                    {
                      offset: 1,
                      color: hexToRgba(color[0], 0.1),
                    },
                  ],
                  false
                ),
                shadowColor: hexToRgba(color[0], 0.1),
                shadowBlur: 10,
              },
            },
            data: yAxisData1,
          },
          {
            name: "风险点和危险源",
            type: "line",
            smooth: true,
            // showSymbol: false,
            symbolSize: 8,
            zlevel: 3,
            lineStyle: {
              normal: {
                color: color[1],
                shadowBlur: 3,
                shadowColor: hexToRgba(color[1], 0.5),
                shadowOffsetY: 8,
              },
            },
            areaStyle: {
              normal: {
                color: new this.$echarts.graphic.LinearGradient(
                  0,
                  0,
                  0,
                  1,
                  [
                    {
                      offset: 0,
                      color: hexToRgba(color[1], 0.3),
                    },
                    {
                      offset: 1,
                      color: hexToRgba(color[1], 0.1),
                    },
                  ],
                  false
                ),
                shadowColor: hexToRgba(color[1], 0.1),
                shadowBlur: 10,
              },
            },
            data: yAxisData2,
          },
        ],
      };
      // 绘制图表
      Chart.setOption(option);
    },
    async bottomDrawLine() {
      const { data: dt } = await this.$http.get(
        "/jeecg-boot/change/change/queryall"
      );
      var valueData = dt.result;
      var value1 = [];
      var value2 = [];
      var value3 = [];
      for (var i in valueData) {
        value1.push(valueData[i].street);
        value2.push(valueData[i].normal);
        value3.push(valueData[i].important);
      }
      let Chart = this.$echarts.init(document.getElementById("bottom_icon"));
      var option = {
        tooltip: {
          trigger: "axis",
          axisPointer: {
            type: "cross",
            crossStyle: {
              color: "#999",
            },
          },
        },
        legend: {
          data: ["一般整改率", "重点整改率"],
        },
        xAxis: [
          {
            type: "category",
            data: value1,
            axisPointer: {
              type: "shadow",
            },
            axisLabel: {
              formatter: "{value} ml",
              textStyle: {
                color: "#fff",
              },
            },
          },
        ],
        yAxis: [
          {
            type: "value",
            name: "水量",
            min: 0,
            max: 250,
            interval: 50,
            axisLabel: {
              formatter: "{value} ml",
              textStyle: {
                color: "#fff",
              },
            },
          },
        ],
        series: [
          {
            name: "一般整改率",
            type: "bar",
            data: value2,
            itemStyle: {
              normal: {
                color: "#00C9FF",
              },
            },
          },
          {
            name: "重点整改率",
            type: "bar",
            data: value3,
            itemStyle: {
              normal: {
                color: "#FFCB59",
              },
            },
          },
        ],
      };
      // 绘制图表
      Chart.setOption(option);
    },
  },
  mounted() {
    this.topDrawLine();
    this.bottomDrawLine();
  },
  created() {},
};
</script>
<style lang="less" scoped>
//@import url(); 引入公共css类
.wisdom {
  overflow: hidden;
  height: 49%;
  //   padding-top: 40px;
  margin-top: 1%;
  box-sizing: border-box;
  background: rgba(8, 32, 58, 0.7);
  .title {
    width: 100%;
    position: relative;
    img {
      width: 100%;
    }
    span {
      font-size: 78px;
      font-weight: 400;
      color: #ffe86b;
      background: linear-gradient(0deg, #bce7ff 0%, #69efff 98.6572265625%);
      -webkit-background-clip: text;
      -webkit-text-fill-color: transparent;
      position: absolute;
      left: 50%;
      top: 0;
      transform: translateX(-50%);
    }
  }
  .content {
    height: calc(100% - 100px);
    .Icon {
      width: 100%;
      height: 50%;
    }
  }
}
@media only screen and (max-width: 2560px) {
  .wisdom {
    height: auto;
    overflow: visible;
    background: transparent;
    margin: 0;
    .content {
      height: auto;
      .Icon {
        height: 2000px;
      }
      .Icon:nth-child(2) {
        padding-left: 200px;
        padding-right: 200px;
      }
    }
  }
}
</style>
